VERSION 5.00
Begin VB.Form frmFindVariables 
   Caption         =   "Find Variables"
   ClientHeight    =   7500
   ClientLeft      =   1590
   ClientTop       =   3045
   ClientWidth     =   17445
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   7500
   ScaleWidth      =   17445
   Begin VB.CommandButton cmdDoWholeProject 
      Caption         =   "Do Project (VBP file)"
      Height          =   855
      Left            =   540
      TabIndex        =   5
      Top             =   2880
      Width           =   1335
   End
   Begin VB.TextBox txtVars 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   6855
      Left            =   8700
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   4
      Top             =   420
      Width           =   8535
   End
   Begin VB.CommandButton cmdDoOneFile 
      Caption         =   "Do One File"
      Height          =   615
      Left            =   540
      TabIndex        =   1
      Top             =   1800
      Width           =   1335
   End
   Begin VB.TextBox txtCode 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   6855
      Left            =   2460
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   420
      Width           =   6075
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   $"FindVariables.frx":0000
      Height          =   1935
      Index           =   0
      Left            =   120
      TabIndex        =   6
      Top             =   3900
      Width           =   2175
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Project should be saved, and not have any syntax errors.  The source-code is only open for 'Input'."
      Height          =   1095
      Index           =   2
      Left            =   120
      TabIndex        =   3
      Top             =   180
      Width           =   2175
   End
   Begin VB.Label Label1 
      Caption         =   "Code that was 'Cleaned' and then examined (One File Only):"
      Height          =   315
      Index           =   1
      Left            =   2520
      TabIndex        =   2
      Top             =   120
      Width           =   5895
   End
End
Attribute VB_Name = "frmFindVariables"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
Private collDeclared As Collection
Private collUnDeclared As Collection
'

Private Sub cmdDoWholeProject_Click()
    Dim sPath As String
    Dim iFle As Long
    Dim sLine As String
    Dim sModSpec As String
    Dim sModCode As String
    Dim sFrmCode As String
    Dim sModName As String
    Dim bFoundModule As Boolean
    Dim v As Variant
    Dim sOutSpec As String
    '
    Set collDeclared = New Collection
    Set collUnDeclared = New Collection
    txtVars.Text = vbNullString
    '
    sPath = GetSetting(App.Title, "Settings", "LastPath", App.Path & "\")
    ShowOpenFileDialog Me.hWnd, "VBP File (*.vbp)" & vbNullChar & "*.vbp" & vbNullChar, sPath, OFN_FILEMUSTEXIST, "Open VB6 Project File"
    If Not FileDialogSuccessful Then Exit Sub
    If UserName = "Elroy" Then SaveSetting App.Title, "Settings", "LastPath", FileDialogFolder  ' Don't mess with anyone else's registry.
    '
    iFle = FreeFile
    Open FileDialogSpec For Input As iFle
    Do
        If EOF(iFle) Then Exit Do
        Line Input #iFle, sLine
        '
        bFoundModule = False
        Select Case True
        Case LeftMatches(sLine, "Module=") Or LeftMatches(sLine, "Class=")
            sModSpec = FileDialogFolder & Trim$(Mid$(sLine, InStr(sLine, ";") + 1))
            bFoundModule = True
        Case LeftMatches(sLine, "Form=") Or LeftMatches(sLine, "UserControl=") Or LeftMatches(sLine, "PropertyPage=")
            sModSpec = FileDialogFolder & Trim$(Mid$(sLine, InStr(sLine, "=") + 1))
            bFoundModule = True
        End Select
        '
        If bFoundModule Then
            sModName = Mid$(sModSpec, InStrRev(sModSpec, "\") + 1)
            sModCode = LoadModCode(sModSpec, sModName)
            txtCode.Text = "Working on: " & sModName
            txtCode.Refresh
            CleanTheModule sModCode
            FindDeclaredVariables sModCode, sModName
            FindUnDeclaredVariables sModCode, sModName
        End If
    Loop
    Close iFle
    '
    txtCode.Text = "Done.  See report on your desktop for results."
    '
    sOutSpec = GetSpecialFolder(CSIDL_DESKTOP) & "Vars for (" & FileDialogName & ").txt"
    iFle = FreeFile
    Open sOutSpec For Output As iFle
    '
    Print #iFle, "Module | Procedure | variable"
    Print #iFle, vbNullString
    Print #iFle, "The following has two lists."
    Print #iFle, "The first is a list of variables with NO declaration (from Let/Set statements)."
    Print #iFle, "The second is a list of variables that DO have declarations."
    Print #iFle, vbNullString
    Print #iFle, "Also, don't forget that globally scoped variables are NOT cross-referenced across modules."
    Print #iFle, vbNullString
    Print #iFle, "****** Variables with NO declarations (from Let/Set statements) ******"
    For Each v In collUnDeclared
        Print #iFle, v
    Next
    '
    Print #iFle, vbNullString
    Print #iFle, vbNullString
    Print #iFle, "****** Variables that DO have declarations (Dim, Public, Private, Static, Redim) ******"
    For Each v In collDeclared
        Print #iFle, v
    Next
    '
    Print #iFle, vbNullString
    Print #iFle, "*** The End ***"
    '
    Close iFle
    '
    ShellEx sOutSpec
End Sub

Private Sub cmdDoOneFile_Click()
    Dim sPath As String
    Dim sModName As String
    Dim sModCode As String
    Dim v As Variant
    Dim sVars As String
    '
    Set collDeclared = New Collection
    Set collUnDeclared = New Collection
    '
    sPath = GetSetting(App.Title, "Settings", "LastPath", App.Path & "\")
    ShowOpenFileDialog Me.hWnd, "BAS, FRM, CLS, CTL, or PAG File (*.bas, *.frm, *.cls, *.ctl, *.pag)" & vbNullChar & "*.bas; *.frm; *.cls; *.ctl; *.pag" & vbNullChar, sPath, OFN_FILEMUSTEXIST, "Open VB6 Module File"
    If Not FileDialogSuccessful Then Exit Sub
    If UserName = "Elroy" Then SaveSetting App.Title, "Settings", "LastPath", FileDialogFolder  ' Don't mess with anyone else's registry.
    '
    sModName = FileDialogName
    sModCode = LoadModCode(FileDialogSpec, sModName)
    CleanTheModule sModCode
    FindDeclaredVariables sModCode, sModName
    FindUnDeclaredVariables sModCode, sModName
    txtCode.Text = sModCode
    '
    sVars = "Module | Procedure | variable" & vbCrLf & vbCrLf & _
            "The following has two lists." & vbCrLf & _
            "The first is a list of variables with NO declaration (from Let/Set statements)." & vbCrLf & _
            "The second is a list of variables that DO have declarations." & vbCrLf & vbCrLf & _
            "****** Variables with NO declarations (from Let/Set statements) ******" & vbCrLf
    For Each v In collUnDeclared
        sVars = sVars & v & vbCrLf
    Next
    '
    sVars = sVars & vbCrLf & vbCrLf & _
            "****** Variables that DO have declarations (Dim, Public, Private, Static, Redim) ******" & vbCrLf
    For Each v In collDeclared
        sVars = sVars & v & vbCrLf
    Next
    '
    sVars = sVars & vbCrLf & "*** The End ***" & vbCrLf
    '
    txtVars.Text = sVars
End Sub

Private Sub FindDeclaredVariables(sModCode As String, sModName As String)
    Dim sModArray() As String
    Dim i As Long
    Dim sWork As String
    Dim iPtr As Long
    Dim sID As String
    Dim sProcName As String
    '
    sProcName = "ModuleLevel"
    sModArray = Split(sModCode, vbCrLf)
    If UBound(sModArray) = -1 Then Exit Sub
    '
    ' Add space to end of each line to make it easier.
    For i = LBound(sModArray) To UBound(sModArray)
        sModArray(i) = sModArray(i) & " "
    Next
    '
    For i = LBound(sModArray) To UBound(sModArray)
        Do  ' Just for a bit of speed providing an excape; not a real loop.
            Select Case True
            Case LeftMatches(sModArray(i), "Sub ")
                sWork = Mid$(sModArray(i), 5): sProcName = Left$(sWork, InStr(sWork, " ") - 1)
            Case LeftMatches(sModArray(i), "Function ")
                sWork = Mid$(sModArray(i), 10): sProcName = Left$(sWork, InStr(sWork, " ") - 1)
            Case LeftMatches(sModArray(i), "Property Let ")
                sWork = Mid$(sModArray(i), 14): sProcName = Left$(sWork, InStr(sWork, " ") - 1)
            End Select
            '
            ' All the declares, constants and all variables.
            If SimpleIdFindAndAdd(sModArray(i), "Dim ", sModName, sProcName) Then Exit Do
            If SimpleIdFindAndAdd(sModArray(i), "Public ", sModName, sProcName) Then Exit Do
            'If SimpleIdFindAndAdd(sModArray(i), "Const ", sModName, sProcName) Then Exit Do    ' We'll skip these for now.
            If SimpleIdFindAndAdd(sModArray(i), "Private ", sModName, sProcName) Then Exit Do
            If SimpleIdFindAndAdd(sModArray(i), "Static ", sModName, sProcName) Then Exit Do
            'If SimpleIdFindAndAdd(sModArray(i), "Redim ", sModName, sProcName) Then Exit Do    ' We'll skip these too, and catch them in the Undimensioned.
            '
            ' Also, all the procedure arguments.
            If ArgIdFindAndAdd(sModArray(i), "Sub ", sModName, sProcName) Then Exit Do
            If ArgIdFindAndAdd(sModArray(i), "Function ", sModName, sProcName) Then Exit Do
            If ArgIdFindAndAdd(sModArray(i), "Property Let ", sModName, sProcName) Then Exit Do
            '
            Exit Do
        Loop
    Next
End Sub

Private Sub FindUnDeclaredVariables(sModCode As String, sModName As String)
    Dim sModArray() As String
    Dim i As Long
    Dim iPtr1 As Long
    Dim iPtr2 As Long
    Dim sWork As String
    Dim sProcName As String
    Dim bFound As Boolean
    '
    sProcName = "ModuleLevel"
    '
    sModArray = Split(sModCode, vbCrLf)
    If UBound(sModArray) = -1 Then Exit Sub
    '
    For i = LBound(sModArray) To UBound(sModArray)
        Do  ' Just for a bit of speed providing an excape; not a real loop.
            If LeftMatches(sModArray(i), "Sub ") Then sWork = Mid$(sModArray(i), 5): sProcName = Left$(sWork, InStr(sWork, " ") - 1): Exit Do
            If LeftMatches(sModArray(i), "Function ") Then sWork = Mid$(sModArray(i), 10): sProcName = Left$(sWork, InStr(sWork, " ") - 1): Exit Do
            If LeftMatches(sModArray(i), "Property Let ") Then sWork = Mid$(sModArray(i), 14): sProcName = Left$(sWork, InStr(sWork, " ") - 1): Exit Do
            '
            iPtr1 = InStr(sModArray(i), " ")
            If iPtr1 Then
                iPtr2 = InStr(sModArray(i), " = ")
                ' If the two pointers are equal, the " = " is the first space found, which means it MUST be a Let line.
                ' Enums are already taken care of.  All other declares should have a prior space.
                If iPtr1 = iPtr2 Then
                    sWork = StripBrackets(Left$(sModArray(i), iPtr1 - 1))
                    bFound = False
                    '
                    ' The following is a filter for things that aren't variables, but it's not a perfect filter.
                    ' This list could be tweaked for specific projects and programming conventions.
                    Select Case True
                    Case InStr(sWork, ".") <> 0
                    Case InStr(sWork, "!") <> 0
                    Case LeftMatches(sWork, "frm")
                    Case LeftMatches(sWork, "frp")
                    Case LeftMatches(sWork, "frz")
                    Case LeftMatches(sWork, "lbl")
                    Case LeftMatches(sWork, "txt")
                    Case LeftMatches(sWork, "cbo")
                    Case LeftMatches(sWork, "chk")
                    Case LeftMatches(sWork, "dtp")
                    Case LeftMatches(sWork, "opt")
                    '
                    Case LeftMatches(sWork, "gb")
                    Case LeftMatches(sWork, "gs")
                    Case LeftMatches(sWork, "gi")
                    '
                    Case LeftMatches(sWork, "Timeout")
                    Case LeftMatches(sWork, "FileDialog")
                    Case LeftMatches(sWork, "Hospital")
                    Case LeftMatches(sWork, "oPodci")
                    Case Else
                        Select Case sWork
                        Case "Left", "Top", "Height", "Width", "Err", "Printer", "MouseIcon", "MousePointer", "Borderstyle"
                        Case "AllowUserInput", "Status", "ViewerTimeout", "ViewerPassword", "FullPassword", "MaintenancePassword", "ProgramMode"
                        Case "dbTheDatabase", "dbTheDatabaseSpec", "dbTheBlankDatabaseSpec"
                        Case "oBraces", "oFalls", "oDragger", "oSrs30", "oPedsql", "oUbet", "oAbilHand", "oWuspi", "oDotsr", "oFaq"
                        Case "RTFCode", "TxtFilling"
                        '
                        ' This is the only option that allows things to continue.
                        Case Else:          bFound = True
                        '
                        End Select
                    End Select
                    '
                    If bFound Then
                        If Not (IsInCollection(collDeclared, sModName & " | ModuleLevel | " & sWork) Or _
                                IsInCollection(collDeclared, sModName & " | " & sProcName & " | " & sWork)) Then
                            '
                            sWork = sModName & " | " & sProcName & " | " & sWork
                            SafeAddCollItem collUnDeclared, sWork, sWork
                        End If
                    End If
                End If
            End If
            '
            Exit Do
        Loop
    Next
End Sub

Private Function SimpleIdFindAndAdd(sLine As String, sNeedle As String, sModName As String, sProcName As String) As Boolean   ' Return TRUE if it was found.
    Dim sWork As String
    Dim s2 As String
    Dim iCnt As Long
    Dim i As Long
    Dim sa() As String
    Dim iPtr As Long
    '
    If Not LeftMatches(sLine, sNeedle) Then Exit Function
    SimpleIdFindAndAdd = True
    '
    ' Create sWork with opening/closing parentheses removed.
    sWork = Mid$(sLine, Len(sNeedle) + 1)
    If TextCount(sWork, "(") <> 0 Then
        iCnt = 0
        For i = 1 To Len(sWork)
            If Mid$(sWork, i, 1) = "(" Then iCnt = iCnt + 1
            If Mid$(sWork, i, 1) = ")" Then
                iCnt = iCnt - 1
            Else
                If iCnt = 0 Then s2 = s2 & Mid$(sWork, i, 1)
            End If
        Next
        sWork = s2
    End If
    sWork = Replace$(sWork, " ", vbNullString)
    sa = Split(sWork, ",")
    '
    ' We must strip any explicit assignments.
    For i = LBound(sa) To UBound(sa)
        iPtr = InStr(sa(i), "=")
        If iPtr <> 0 Then sa(i) = Trim$(Left$(sa(i), iPtr - 1))
    Next i
    '
    ' We've finally got the arguments.  Now we can add them to the collection.
    For i = LBound(sa) To UBound(sa)
        sa(i) = StripBrackets(sa(i))
        sWork = sModName & " | " & sProcName & " | " & sa(i)
        SafeAddCollItem collDeclared, sWork, sWork
    Next
End Function

Private Function ArgIdFindAndAdd(sLine As String, sNeedle As String, sModName As String, sProcName As String) As Boolean   ' Return TRUE if it was found.
    ' We can use the SimpleIdFindAndAdd for the procedure (and Type and Enum) names.
    ' But the actual arguments must be handled differently.
    '
    Dim iLen As Long
    Dim sID As String
    Dim iPtr As Long
    Dim sWork As String
    Dim iCnt As Long
    Dim sa() As String
    Dim i As Long
    Dim iCnt2 As Long
    Dim s2 As String
    '
    If Not LeftMatches(sLine, sNeedle) Then Exit Function
    ArgIdFindAndAdd = True
    '
    ' If we go ahead and add the procedure names too. Functions will be a variable, and Property Let/Set too.
    iLen = Len(sNeedle) + 1
    iPtr = InStr(iLen, sLine, " ")
    sID = StripBrackets(Mid$(sLine, iLen, iPtr - iLen))
    sWork = sModName & " | " & sID & " | " & sID
    SafeAddCollItem collDeclared, sWork, sWork      ' ID keys will be unique.
    '
    ' Get rid of array indicators.
    sLine = Replace$(sLine, " ( ) ", " ")
    '
    ' We should just have one (or NO) set of () at this point.
    ' Although the UDT Type statement (our quasi-function) may have arrays in it.
    iCnt = TextCount(sLine, "(")
    If iCnt = 0 Then Exit Function          ' No arguments.
    '
    ' Create sWork, with opening/closing parentheses removed, and remove spaces.
    sWork = Trim$(Mid$(sLine, InStr(sLine, "(") + 1))
    If Right$(sWork, 1) <> ")" Then Error 16
    sWork = Trim$(Left$(sWork, Len(sWork) - 1))
    sWork = Replace$(sWork, " ", vbNullString)
    '
    ' We just treat all other parentheses similar to a string, and delete them.  Arrays, enums with (#) assignments, possibly Optional default values.
    If iCnt > 1 Then
        iCnt2 = 0
        For i = 1 To Len(sWork)
            If Mid$(sWork, i, 1) = "(" Then iCnt2 = iCnt2 + 1
            If Mid$(sWork, i, 1) = ")" Then
                iCnt2 = iCnt2 - 1
            Else
                If iCnt2 = 0 Then s2 = s2 & Mid$(sWork, i, 1)
            End If
        Next
        sWork = s2
    End If
    '
    ' We can now make our argument list.
    sa = Split(sWork, ",")
    '
    ' We must strip any explicit assignments.  Enums, Optional default values.
    For i = LBound(sa) To UBound(sa)
        iPtr = InStr(sa(i), "=")
        If iPtr <> 0 Then sa(i) = Trim$(Left$(sa(i), iPtr - 1))
    Next i
    '
    ' We've finally got the arguments.  Now we can add them to the collection.
    For i = LBound(sa) To UBound(sa)
        sa(i) = StripBrackets(sa(i))
        sWork = sModName & " | " & sProcName & " | " & sa(i)
        SafeAddCollItem collDeclared, sWork, sWork     ' ID keys will be unique.
    Next
End Function

Private Function LoadModFormCode(sModSpec As String, sModName As String) As String
    Dim iFle As Long
    Dim sLine As String
    '
    iFle = FreeFile
    Open sModSpec For Input As iFle
    Do While Not EOF(iFle)
        Line Input #iFle, sLine
        If LeftMatches(sLine, "Attribute VB_Name") Then Exit Do
        LoadModFormCode = LoadModFormCode & sLine & vbCrLf
    Loop
    Close iFle
End Function

Private Function LoadModCode(sModSpec As String, sModName As String) As String
    Dim iFle As Long
    Dim sLine As String
    Dim bFoundCode As Boolean
    Dim sWork As String
    '
    LoadModCode = vbCrLf    ' Let's put a blank line at the top.
    iFle = FreeFile
    Open sModSpec For Input As iFle
    Do While Not EOF(iFle)
        Line Input #iFle, sLine
        If Not bFoundCode Then If LeftMatches(Trim$(sLine), "Attribute VB_Name") Then bFoundCode = True
        If bFoundCode Then LoadModCode = LoadModCode & sLine & vbCrLf
    Loop
    Close iFle
End Function

Private Sub CleanTheModule(sModCode As String)
    sModCode = FilterWhite(sModCode)
    sModCode = FilterComments(sModCode)
    sModCode = FilterStrings(sModCode)
    sModCode = FilterWhite(sModCode)                                    ' We filter white again because filtering strings may leave some double-spaces.
    sModCode = FilterBlankLines(sModCode)
    '
    sModCode = Replace$(sModCode, " _" & vbCrLf, " ")                   ' Concatenate line continuations.
    sModCode = Replace$(sModCode, ": ", vbCrLf)                         ' Split colon lines.
    '
    ' Simplify variable declarations.
    sModCode = Replace$(sModCode, "WithEvents ", vbNullString)
    '
    ' Do some simplification of the procedure declarations.
    sModCode = Replace$(sModCode, "Static Sub ", "Sub ")
    sModCode = Replace$(sModCode, "Static Function ", "Function ")
    sModCode = Replace$(sModCode, "Static Property ", "Property ")
    '
    sModCode = Replace$(sModCode, "Private Sub ", "Sub ")
    sModCode = Replace$(sModCode, "Public Sub ", "Sub ")
    sModCode = Replace$(sModCode, "Friend Sub ", "Sub ")
    '
    sModCode = Replace$(sModCode, "Private Function ", "Function ")
    sModCode = Replace$(sModCode, "Public Function ", "Function ")
    sModCode = Replace$(sModCode, "Friend Function ", "Function ")
    '
    sModCode = Replace$(sModCode, "Private Property ", "Property ")
    sModCode = Replace$(sModCode, "Public Property ", "Property ")
    sModCode = Replace$(sModCode, "Friend Property ", "Property ")
    '
    sModCode = Replace$(sModCode, "Property Set ", "Property Let ")     ' Just make them all "Property Let".
    sModCode = Replace$(sModCode, "Property Get ", "Property Let ")     ' Just make them all "Property Let".
    '
    ' Simplify the API declarations.
    sModCode = Replace$(sModCode, "Public Declare ", "Declare ")
    sModCode = Replace$(sModCode, "Private Declare ", "Declare ")
    sModCode = Replace$(sModCode, "Lib ", vbNullString)
    sModCode = Replace$(sModCode, "Alias ", vbNullString)
    '
    ' Simplify constants.
    sModCode = Replace$(sModCode, "Public Const ", "Const ")
    sModCode = Replace$(sModCode, "Private Const ", "Const ")
    '
    ' Some similifying of arguments.
    sModCode = Replace$(sModCode, "(Optional ", "(")
    sModCode = Replace$(sModCode, ", Optional ", ", ")
    sModCode = Replace$(sModCode, "(ByVal ", "(")
    sModCode = Replace$(sModCode, ", ByVal ", ", ")
    sModCode = Replace$(sModCode, "(ByRef ", "(")
    sModCode = Replace$(sModCode, ", ByRef ", ", ")
    sModCode = Replace$(sModCode, "(ParamArray ", "(")
    sModCode = Replace$(sModCode, ", ParamArray ", ", ")
    '
    ' Simplify "Type" and "Enum".
    sModCode = Replace$(sModCode, "Public Type ", "Type ")
    sModCode = Replace$(sModCode, "Private Type ", "Type ")
    sModCode = Replace$(sModCode, "Public Enum ", "Enum ")
    sModCode = Replace$(sModCode, "Private Enum ", "Enum ")
    '
    sModCode = MakeTypesLookLikeFunctions(sModCode)
    sModCode = MakeEnumsLookLikeFunctions(sModCode)
    '
    ' Put a space before all "," and ")".  It just makes things easier.  Also, "(" gets spaces on both sides.
    sModCode = Replace$(sModCode, ",", " ,")
    sModCode = Replace$(sModCode, ")", " )")
    sModCode = Replace$(sModCode, "(", " ( ")
    '
    sModCode = RemoveAllTypesFromDeclares(sModCode)
    sModCode = FilterWhite(sModCode)
    '
    ' For grins, just get rid of some stuff.  It makes staring at code for debugging easier.
    '
    BlankLinesStartingWith ".", sModCode
    BlankLinesStartingWith "End ", sModCode
    BlankLinesThatAre "End", sModCode
    BlankLinesStartingWith "#End ", sModCode
    BlankLinesStartingWith "Select ", sModCode
    BlankLinesStartingWith "Case ", sModCode
    BlankLinesStartingWith "If ", sModCode
    BlankLinesStartingWith "#If ", sModCode
    BlankLinesStartingWith "Else ", sModCode
    BlankLinesThatAre "Else", sModCode
    BlankLinesStartingWith "#Else ", sModCode
    BlankLinesThatAre "#Else", sModCode
    BlankLinesStartingWith "ElseIf ", sModCode
    BlankLinesThatAre "ElseIf", sModCode
    BlankLinesStartingWith "#ElseIf ", sModCode
    BlankLinesThatAre "#ElseIf", sModCode
    BlankLinesStartingWith "On Error ", sModCode
    BlankLinesStartingWith "Exit ", sModCode
    BlankLinesStartingWith "Next ", sModCode
    BlankLinesThatAre "Next", sModCode
    BlankLinesStartingWith "Open ", sModCode
    BlankLinesStartingWith "Close ", sModCode
    BlankLinesStartingWith "Print ", sModCode
    BlankLinesStartingWith "Input ", sModCode
    BlankLinesStartingWith "Line Input ", sModCode
    BlankLinesStartingWith "LSet ", sModCode
    BlankLinesStartingWith "With ", sModCode
    BlankLinesStartingWith "Seek ", sModCode
    BlankLinesStartingWith "Erase ", sModCode
    BlankLinesThatAre "Do", sModCode
    BlankLinesThatAre "Loop", sModCode
    BlankLinesStartingWith "Unload ", sModCode
    '
    ' And now, let's clean-up any explicit Let statements, and also Set statements.
    sModCode = Replace$(sModCode, vbCrLf & "Let ", vbCrLf)
    sModCode = Replace$(sModCode, vbCrLf & "Set ", vbCrLf)
    sModCode = Replace$(sModCode, vbCrLf & "For ", vbCrLf)
    sModCode = Replace$(sModCode, vbCrLf & "Do While ", vbCrLf)
    sModCode = Replace$(sModCode, vbCrLf & "Do Until ", vbCrLf)
    sModCode = Replace$(sModCode, vbCrLf & "Loop While ", vbCrLf)
    sModCode = Replace$(sModCode, vbCrLf & "Loop Until ", vbCrLf)
    sModCode = Replace$(sModCode, vbCrLf & "Redim ", vbCrLf)
    '
    sModCode = FilterBlankLines(sModCode)
End Sub

Private Function RemoveAllTypesFromDeclares(sModCode As String) As String
    Dim sModArray() As String
    Dim i As Long
    Dim iPtr1 As Long
    Dim iPtr2 As Long
    '
    sModArray = Split(sModCode, vbCrLf)
    If UBound(sModArray) = -1 Then Exit Function
    '
    ' Add space to end of each line to make it easier.
    For i = LBound(sModArray) To UBound(sModArray)
        sModArray(i) = sModArray(i) & " "
    Next
    '
    For i = LBound(sModArray) To UBound(sModArray)
        Do
            iPtr1 = InStr(sModArray(i), " As ")
            If iPtr1 = 0 Then Exit Do
            iPtr2 = InStr(iPtr1 + 4, sModArray(i), " ")
            If iPtr1 > iPtr2 Then Exit Do
            sModArray(i) = Left$(sModArray(i), iPtr1 - 1) & Mid$(sModArray(i), iPtr2)
        Loop
    Next
    RemoveAllTypesFromDeclares = Join(sModArray, vbCrLf)
End Function

Private Sub BlankLinesStartingWith(sStart As String, sModCode As String)
    Dim sModArray() As String
    Dim i As Long
    '
    sModArray = Split(sModCode, vbCrLf)
    If UBound(sModArray) = -1 Then Exit Sub
    '
    For i = LBound(sModArray) To UBound(sModArray)
        If LeftMatches(sModArray(i), sStart) Then sModArray(i) = vbNullString
    Next
    sModCode = Join(sModArray, vbCrLf)
End Sub

Private Sub BlankLinesThatAre(sStart As String, sModCode As String)
    Dim sModArray() As String
    Dim i As Long
    '
    sModArray = Split(sModCode, vbCrLf)
    If UBound(sModArray) = -1 Then Exit Sub
    '
    For i = LBound(sModArray) To UBound(sModArray)
        If sModArray(i) = sStart Then sModArray(i) = vbNullString
    Next
    sModCode = Join(sModArray, vbCrLf)
End Sub

Private Function MakeTypesLookLikeFunctions(sModCode As String) As String
    Dim sModArray() As String
    Dim i As Long
    Dim j As Long
    '
    sModArray = Split(sModCode, vbCrLf)
    If UBound(sModArray) = -1 Then Exit Function
    '
    For i = LBound(sModArray) To UBound(sModArray)
        If LeftMatches(sModArray(i), "Type ") Then
            sModArray(i) = sModArray(i) & "("
            j = i + 1
            Do
                If sModArray(j) = "End Type" Then
                    sModArray(i) = sModArray(i) & ")"
                    Exit Do
                End If
                If j <> i + 1 Then sModArray(i) = sModArray(i) & ", "
                sModArray(i) = sModArray(i) & sModArray(j)
                sModArray(j) = vbNullString
                j = j + 1
            Loop
        End If
    Next
    MakeTypesLookLikeFunctions = Join(sModArray, vbCrLf)
End Function

Private Function MakeEnumsLookLikeFunctions(sModCode As String) As String
    Dim sModArray() As String
    Dim i As Long
    Dim j As Long
    '
    sModArray = Split(sModCode, vbCrLf)
    If UBound(sModArray) = -1 Then Exit Function
    '
    For i = LBound(sModArray) To UBound(sModArray)
        If LeftMatches(sModArray(i), "Enum ") Then
            sModArray(i) = sModArray(i) & "("
            j = i + 1
            Do
                If sModArray(j) = "End Enum" Then
                    sModArray(i) = sModArray(i) & ")"
                    Exit Do
                End If
                If j <> i + 1 Then sModArray(i) = sModArray(i) & ", "
                sModArray(i) = sModArray(i) & sModArray(j)
                sModArray(j) = vbNullString
                j = j + 1
            Loop
        End If
    Next
    MakeEnumsLookLikeFunctions = Join(sModArray, vbCrLf)
End Function

Private Function FilterBlankLines(sModCode As String) As String
    FilterBlankLines = sModCode
    ' This leaves the blank line at the top.
    Do While InStr(FilterBlankLines, vbCrLf & vbCrLf)
        FilterBlankLines = Replace$(FilterBlankLines, vbCrLf & vbCrLf, vbCrLf)
    Loop
End Function

Private Function FilterWhite(sModCode As String) As String
    Dim sModArray() As String
    Dim i As Long
    '
    sModCode = Replace$(sModCode, vbTab, " ")
    Do While InStr(sModCode, "  ")
        sModCode = Replace$(sModCode, "  ", " ")
    Loop
    '
    sModArray = Split(sModCode, vbCrLf)
    If UBound(sModArray) = -1 Then Exit Function
    '
    For i = LBound(sModArray) To UBound(sModArray)
        sModArray(i) = Trim$(sModArray(i))
    Next
    '
    FilterWhite = Join(sModArray, vbCrLf)
End Function

Private Function FilterComments(sModCode As String) As String
    Dim sModArray() As String
    Dim i As Long
    Dim iStart As Long
    Dim iPtr As Long
    '
    sModArray = Split(sModCode, vbCrLf)
    If UBound(sModArray) = -1 Then Exit Function
    '
    For i = LBound(sModArray) To UBound(sModArray)
        iStart = 1
        Do
            iPtr = InStr(iStart, sModArray(i), "'")
            If iPtr = 0 Or iPtr = Len(sModArray(i)) - 1 Then Exit Do
            If Not InsideString(sModArray(i), iPtr) Then
                sModArray(i) = Left$(sModArray(i), iPtr - 1)
                Exit Do
            End If
            iStart = iPtr + 1
        Loop
    Next
    '
    FilterComments = Join(sModArray, vbCrLf)
End Function

Private Function FilterStrings(sModCode As String) As String
    Dim sModArray() As String
    Dim i As Long
    Dim bFlop As Boolean
    Dim iStart As Long
    Dim iPtr As Long
    '
    sModArray = Split(sModCode, vbCrLf)
    If UBound(sModArray) = -1 Then Exit Function
    '
    For i = LBound(sModArray) To UBound(sModArray)
        bFlop = False
        iStart = 1
        Do
            iPtr = InStr(iStart, sModArray(i), """")
            If iPtr = 0 Then Exit Do
            If Not bFlop Then
                iStart = iPtr + 1
                bFlop = True
            Else
                sModArray(i) = Left$(sModArray(i), iStart - 2) & Mid$(sModArray(i), iPtr + 1)
                iStart = iPtr - (iPtr - iStart + 1)
                bFlop = False
            End If
        Loop
    Next
    '
    FilterStrings = Join(sModArray, vbCrLf)
End Function

Private Function InsideString(sLine As String, iPtr As Long) As Boolean
    ' This should handle regular strings as well as strings with escaped quotes in them, like "   ""   ".
    ' The only problem would be if we were pointing directly at a quote mark, which we won't do.
    InsideString = TextCount(Left$(sLine, iPtr - 1), """") Mod 2 <> 0
End Function

Private Function TextCount(sHay As String, sNeedle As String) As Long
    ' Will error if no sNeedle given.
    ' Counts the occurrences if a string (sNeedle).
    TextCount = (Len(sHay) - Len(Replace(sHay, sNeedle, ""))) / Len(sNeedle)
End Function

Private Function StripBrackets(sID As String) As String
    If Left$(sID, 1) = "[" And Right$(sID, 1) = "]" Then
        StripBrackets = Mid$(sID, 2, Len(sID) - 2)
    Else
        StripBrackets = sID
    End If
End Function

